import java.awt.*;
import java.awt.event.*;
public class LUPivot extends Frame
{
   public LUPivot()
   {  
      setSize(800,300);
      addWindowListener(new WindowAdapter()
      {
         public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public int MaxPivot(double [][] A, int K, int N)//őΊpvf߂
   {  int ID = K;int j;
      for(j=K+1;j<N;j++) if(Math.abs(A[ID][K])<Math.abs(A[j][K])) ID=j;
      return ID;
   }
   public void ExchangeLine(int K1, int K2, double [][] A, int N)//sւ
   {  int i;double T;
      for(i=0; i<N; i++){ T = A[K1][i];A[K1][i]=A[K2][i];A[K2][i]=T;}
   }
   public double[][] SetUnitMat(int N)//Pʍsݒ
   {   double[][] X=new double [N][N];
       int i,j;
       for(i=0;i<N;i++)for(j=0;j<N;j++)X[i][j]=(i==j? 1: 0); 
       return X;
   }
   public double[][] SetExMat(int K1, int K2, int N)//usݒ
   {  double[][] X = SetUnitMat(N);
      if(K1 != K2) ExchangeLine(K1, K2, X, N);
      return X;
   }
                                                     //sZ
   public double[][] MultM(double [][] A,double [][] B,int N1,int N2, int N3)
   {
      int i,j,k;double[][] C = new double [N1][N3];
      for(i=0;i<N1;i++) for(j=0;j<N3; j++)
      {  C[i][j]=0.0;
         for(k=0;k<N2;k++) C[i][j] += A[i][k] * B[k][j];
      }
      return C;
   }
   public double [][] TransMat(double [][] A, int K, int N)//ϊsݒ
   {  double [][] G = SetUnitMat(N);
      int i; for(i=K+1; i<N; i++) G[i][K] = -A[i][K] / A[K][K];
      return G;
   }
   public int InvMat(double[][] A,int N, double Eps) // ts
   {  int i, j, k; int N2 = N * 2;
      for(i=0;i<N;i++) for(j=0;j<N;j++) A[i][j+N] = ( i==j? 1 : 0);
      for(k=0;k<N;k++)
      {   if(Math.abs(A[k][k])<Eps) return 1;
          for(j=k+1;j< N2;j++) A[k][j] /= A[k][k];
          for(i=0;i<N;i++)
             if(i != j) for(j=k+1;j<N2;j++) A[i][j] -= A[i][k]*A[k][j];
      }
      return 0;
   }
   public void SetPivotResult(double[][] A, double[][]R,int N)//tsvZʐݒ
   {  int i,j;
      for(i=0;i<N;i++) for(j=0;j<N;j++) R[i][j]=A[i][j];
   }
   public void CopyArray(double[][] A, double[][]R,int N)//z񕡎
   {  int i,j;
      for(i=0;i<N;i++) for(j=0;j<N;j++) R[i][j]=A[i][j];
   }
   
   public void LU_D_Pivot(double[][] A,double[][] L,double[][] U,double[][] multP,int N)
   {
      double [][] G  = new double[N][N]  ;// ϊs
      double [][] GB = new double[N][N]  ;// Gn-1ۑps
      double [][] P  = new double[N][N]  ;// us
      double [][] C  = new double[N][N]  ;// ZpƗ̈
      double [][] CC = new double[N][N]  ;// ZpƗ̈
      double [][] CX = new double[N][N*2];// tsvZp
      double [][] H  = SetUnitMat(N)    ;// OpspHi
              multP  = SetUnitMat(N)    ;// multPPʍs
      int i;
      for(i = 0; i < N-1; i++)
      {  P = SetExMat(i,MaxPivot(A,i,N),N); // usPiݒ
         C = MultM(P, A, N, N, N);          // C  = Pi*Ai-1
         G = TransMat(C, i, N);             // Oi̕ϊ}gbNX
         A = MultM(G, C, N, N, N);             // Ai = Gi*C
         if(i>0)                            // i=0̂ƂGi-1Ȃ 
         {  C  = MultM(GB, H, N, N, N);     // Hi= Pi * Gi-1 * Hi-2 * Pi^(-1)
            CC = MultM( P, C, N, N, N);        
            H  = MultM(CC, P, N, N, N);     // Pi^(-1) = Piɒ
         }
         C = MultM(P,multP, N, N, N);       // Pmult = Pi * Pmult
         CopyArray(C, multP,N);
         CopyArray(G, GB   ,N);             // Gi-1ۑ
      }
      CC=MultM(G, H, N, N, N);              // CC=Gn-1 * Hn-2
      CopyArray(CC,CX,N);                   // CC̋ts߂
      int R=InvMat(CX,N,0.00001);           // 
      SetPivotResult(CX,L,N);               // tsOpsƂ
      CopyArray(A,U,N);                     // An-1OpsƂ
   }

   public void drawBra(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X + 2,Y);g.drawLine( X,Y + H, X + 2, Y + H);
   }
   public void drawKet(Graphics g, int X, int Y, int H)
   {  g.drawLine( X, Y, X, Y + H);g.drawLine( X, Y, X - 2,Y);g.drawLine( X,Y + H, X - 2, Y + H);
   }
   private double round(double D,int N)
   {  
      double DN=10*Math.pow(10.0,(double)(N-1));
      if(Math.abs(D*DN)<0.5) return 0.0;
      return (Math.rint(D*DN))/DN;
   }
   public void DrawExp(Graphics g, String ope1,String ope2, int Y,
                       double [][] A,double [][] B,double [][] C,int N1,int N2)
   {  int i, j;
      g.drawString( ope1,210,Y+20);
      g.drawString( ope2,410,Y+20);
      for(i=0;i<N1;i++) for(j=0;j<N2; j++)
      {  g.drawString( "" + round(A[i][j],3), 50 + j*50,Y + i*20);
         g.drawString( "" + round(B[i][j],3),250 + j*50,Y + i*20);
         g.drawString( "" + round(C[i][j],3),450 + j*50,Y + i*20);
      }
      drawBra(g, 40, Y - 10, 50); drawKet(g,200, Y - 10, 50);
      drawBra(g,240, Y - 10, 50); drawKet(g,400, Y - 10, 50);
      drawBra(g,440, Y - 10, 50); drawKet(g,600, Y - 10, 50);
   } 
   public void paint(Graphics g)
   {  int i,j;
      double [][] A={{6,5,4},{12,13,10},{18,21,17}};
      double [][] L={{0,0,0},{0,0,0},{0,0,0}};
      double [][] U={{0,0,0},{0,0,0},{0,0,0}};
      double [][] multP={{0,0,0},{0,0,0},{0,0,0}};
      setTitle("LU");
      LU_D_Pivot(A, L, U, multP, 3);
      DrawExp(g, "","", 50, A, L, U, 3,3);
      double [][] C = MultM(L, U, 3, 3, 3);
      DrawExp(g, "","", 150, L, U, C, 3,3);
   } 
   public static void main(String[] args)
   {
      Frame w = new LUPivot();
      w.setVisible(true);
   }

}
